; WLA-Z80 9.0a bug example
; Gives the error:
; object.o:labelbug.asm:58: FIX_REFERENCES: Too large distance (135 bytes from $8018 to $80a0 "-") for a 8bit reference.
; Replacing the "-" with "_loop" or similar allows it to compile
; (two later "+" labels also exhibit the bug)
; Works fine with all WLA DX prior to bugfix for .rept anonymous label bug

.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE $7ff0
SLOT 0 $0000
SLOTSIZE $0010
SLOT 1 $7ff0
SLOTSIZE $4000
SLOT 2 $8000
.ENDME

.ROMBANKMAP
BANKSTOTAL 32
BANKSIZE $7ff0
BANKS 1
BANKSIZE $0010
BANKS 1
BANKSIZE $4000
BANKS 30
.ENDRO

;=======================================================================================================
; SMS-specific stuff:
;=======================================================================================================
; Ports:
.define PSG             $7f ; w

;=======================================================================================================
; Bank 12: $30000 - $33fff - sound engine
;=======================================================================================================
.bank 12 slot 2
.orga $8000
.section "Sound engine initialisation" overwrite
SoundInitialise:       ; $8000
    push hl
    push de
    push bc
       ;call _ZeroC003toC00D
        ld b,$f        ; counter
        ld hl,$c00e    ; start
        xor a          ; 0 -> a
	.db $ff,$ff,$ff,$ff
test1:	
      -:ld (hl),a      ; 0 -> c00e,c02e,c04e ... c1ce
        ld de,$18
        add hl,de
        ld (hl),a      ; 0 -> c026,c046,c066 ... c1e6
        inc hl
        ld (hl),a      ; 0 -> c027,c047,c067 ... c1e7
        inc hl
        ld (hl),a      ; 0 -> c028,c048,c068 ... c1e8
        ld de,$6
        add hl,de
	.db $ff,$ff,$ff,$ff
        djnz -
test2:	
    pop bc
    pop de
    pop hl
; fall through
SilencePSGandFM:       ; $801f
    push hl
    push bc
        ld hl,SilencePSGData
        ld c,PSG
        ld b,SilencePSGDataEnd-SilencePSGData
        otir
    pop bc
    pop hl
; fall through
SilenceFM:             ; $802c
    push bc
    push de
        ld b,6         ; 6 channels
        ld d,$20       ; YM2413 registers $20-$26
       -:ld a,d
        inc d
        ;call ZeroYM2413Register
        djnz -
    pop de
    pop bc
    ret ; from SoundInitialise, SilencePSG or SilenceFM

_ZeroC003toC00D:       ; Zero $c003-$c00d
    xor a
    ld hl,$c003
    ld (hl),a
    ld de,$c004
    ld bc,10
    ldir
    ret
.ends
; followed by
.section "PSG silencing data" overwrite
SilencePSGData:        ; $804a
.db $80,$00            ; ch 0 f $000
.db $A0,$00            ; ch 1 f $000
.db $C0,$00            ; ch 2 f $000
.db $E5,$FF            ; ch 3 f %101 = white, med and then volume $f = off ################# could not bother with the $e5?
SilencePSGDataEnd:
.ends

; followed by
;.orga $8052
.section "Sound update" overwrite
SoundUpdate:           ; $8052
    ;ld a,(HasFM)
    or a
    ex af,af'
    ld hl,$c00c
    exx                ; bc de hl <-> bc' de' hl'
    ;call fn8135
    ;call fn815c
    call $8466
    ;call fn8110
    ;ld a,(HasFM)
    or a
    ;jp z,fn80bf        ; if not HasFM
    ld a,($c002)
    or a
    jp m,fn809a
    ld ix,$c00e
    ld b,$0a
  -:push bc            ; <-----+
        ld a,$04       ;       |
        cp b           ;       |
        jr z,+         ; --+   |
        bit 7,(ix+0)   ;   |   |
        call nz,$8664  ;   |   |
     --:ld de,$20      ; <-|-+ |
        add ix,de      ;   | | |
    pop bc             ;   | | |
    djnz -             ; --|-|-+
    ret                ;   | |
                       ;   | |
  +:bit 7,(ix+0)       ; <-+ |
    call nz,$8608      ;     |
    jr --              ; ----+
.ends
; followed by
.orga $809a
.section "fn809a" overwrite
fn809a:                ; $809a
    ld ix,$c0ee
    ld b,$8
  -:push bc            ; <-----+
        ld a,1         ;       |
        cp b           ;       |
        jr z,+         ; --+   |
        bit 7,(ix+0)   ;   |   |
        call nz,$8664  ;   |   |
     --:ld de,$20      ; <-|-+ |
        add ix,de      ;   | | |
    pop bc             ;   | | |
    djnz -             ; --|-|-+
    ret                ;   | |
                       ;   | |
  +:bit 7,(ix+0)       ; <-+ |
    call nz,$8608      ;     |
    jr --              ; ----+
.ends
